<?php
/**
 * EAPC NS Manager functions
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Eduard Díaz <eventgrafic@gmail.com>
 *
 */

if (!defined('DOKU_INC')) die();
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'admin.php');

include_once(DOKU_PLUGIN.'dirmanagereapc/lib/fileactions.php');

class admin_plugin_dirmanagereapc extends DokuWiki_Admin_Plugin {
    var $version = '2008-12-1';

    function admin_plugin_odteapc(){
        $this->setupLocale();
    }

    function getInfo() {
        return array(
                'author' => 'Eduard Diaz',
                'email'  => 'edudiaz@scopia.es',
                'date'   => $this->version,
                'name'   => 'EAPC NS Manager (admin component)',
                'desc'   => 'Namespaces manager',
                'url'    => 'http://www.scopia.es/',
                );
    }

    function getMenuSort() {
        return 815;
    }

    function forAdminOnly(){
        return true;
    }

    function handle() {
        global $AUTH_ACL;
        global $ID;
        if (!empty($_REQUEST['dir'])) {
            $this->dirtree = $_REQUEST['dir'];
        }
        if (!empty($_REQUEST['dir2'])) {
            $this->dirto = $_REQUEST['dir2'];
        }
        if (!empty($_REQUEST['action'])) {
            $this->fileaction = $_REQUEST['action'];
        }
    }

    function html() {

      echo $this->locale_xhtml('intro');

      $cpanel = wl($ID).(strpos(wl($ID),'?')?'&amp;':'?').'do=admin';

      ?>
        <script type="text/javascript">
        var ajaxfiletree = "<?php echo DOKU_BASE?>lib/plugins/dirmanagereapc/ajaxfiletree.php";
        var ajaxfileaction = "<?php echo DOKU_BASE?>lib/plugins/dirmanagereapc/ajaxfileaction.php";
        </script>
        <script src="<?php echo DOKU_TPL?>js/dokuFileTree.js" type="text/javascript"></script>
        <script src="<?php echo DOKU_TPL?>js/init_nstree.js" type="text/javascript"></script>
        <div class="nsmanagertree">
		    <div class="fileTreeContainer">
			    <h1><?php echo $this->getLang('title_namespaces')?></h1>
			    <p><?php echo $this->getLang('tool_info')?></p>
			    <div id="fileTreeDemo_1" class="tree"></div>
			    <div id="fileTreeActions" class="fileinfo">
			        <h2><?php echo $this->getLang('root_directori')?></h2>
			        <form action="" method="post">
			            <input type="hidden" value="" name="srcid" id="id_srcid"/>
			            <input type="hidden" value="" name="srcpath" id="id_srcpath"/>
			            <input type="hidden" value="" name="action" id="id_action"/>
			            <input type="hidden" value="" name="dstpath" id="id_dstpath"/>
			            <input type="button" class="button" name="delete" value="<?php echo $this->getLang('delete')?>" />
			            <input type="button" class="button" name="rename" value="<?php echo $this->getLang('rename')?>" />
			            <input type="button" class="button" name="copy" value="<?php echo $this->getLang('copy')?>" />
			            <input type="button" class="button" name="move" value="<?php echo $this->getLang('move')?>" />
			            <input type="button" class="button" name="cancel" value="<?php echo $this->getLang('cancel')?>" />
			            <p class="treeinfo"><span class="path">/</span></p>
			            <p class="msg"></p>
		            </form>
			    </div>
		    </div>
		    <ul id="myMenu" class="contextMenu">
			    <li class="rename"><a href="#rename"><?php echo $this->getLang('rename')?></a></li>
                <li class="delete"><a href="#delete"><?php echo $this->getLang('delete')?></a></li>			    
			    <li class="cut separator"><a href="#cut"><?php echo $this->getLang('cut')?></a></li>
			    <li class="copy"><a href="#copy"><?php echo $this->getLang('copy')?></a></li>
			    <li class="paste"><a href="#paste"><?php echo $this->getLang('paste')?></a></li>
			    <li class="quit separator"><a href="#quit"><?php echo $this->getLang('quit')?></a></li>
		    </ul>
	    </div>
	    <div class="fix"></div>
        <p style="margin-top:1em;"><a href="<?php echo $cpanel ?>">&laquo; <?php echo $this->getLang('back_cpanel');?></a></p>
      <?php
    }

    function treedirectory($dir){
        global $conf;
        $root = realpath($conf['datadir']);
        if ($dir[strlen($dir)-1]!='/') $dir .= '/';
        if( file_exists($root . $dir) ) {
	        $files = scandir($root . $dir);
	        natcasesort($files);
	        if( count($files) > 2 ) {
		        echo "<ul class=\"jqueryFileTree\" style=\"display: none;\">";
		        foreach( $files as $file ) {
			        if( file_exists($root . $dir . $file) && $file != '.' && $file != '..' && is_dir($root . $dir . $file) && $file != '.svn') {
			            $dirID = uniqid();
				        echo "<li class=\"directory collapsed\" id=\"d".$dirID."\">";
				        echo "<a href=\"#\" rel=\"" . htmlentities($dir . $file) . "/\">" . htmlentities($file) . "</a>";
				        echo "</li>";
			        }
		        }
		        foreach( $files as $file ) {
			        if( file_exists($root . $dir . $file) && $file != '.' && $file != '..' && !is_dir($root . $dir . $file) ) {
				        $fileID = uniqid();
				        $ext = preg_replace('/^.*\./', '', $file);
				        echo "<li class=\"file ext_$ext\" id=\"f".$fileID."\">";
				        echo "<a href=\"#\" rel=\"" . htmlentities($dir . $file) . "\">" . htmlentities($file) . "</a>";
				        echo "</li>";
			        }
		        }
		        echo "</ul>";	
	        }
        }
    }

    function filemanager($from, $to, $action){
        global $conf;
        $root = realpath($conf['datadir']);
        $dstdir = $root.$from;
        if (!is_dir($dstdir) && !is_file($dstdir) ){
            echo '{"error":"'.$this->getLang('error_no_exist_file').'"}';
            return;
        }
        if ($action == 'delete') {
            if (unlinkDir($dstdir)) echo '{"action":"delete","msg":"<strong>'.str_replace($root,'',$dstdir).'</strong> '.$this->getLang('deleted').'"}';
            else echo '{"action":"delete","error":"'.$this->getLang('error_delete').'"}';
            return;

        } else if ( !empty($to) ){
            $srcdir = $dstdir;
            if ($to{0}=='/') $dstdir = $root.$to;
            else $dstdir = $root.'/'.$to;

            if ($action == 'copy') {
                if (dir_copy($srcdir, $dstdir)) echo '{"action":"copy","msg":"<strong>'.str_replace($root,'',$dstdir).'</strong> '.$this->getLang('copied').'"}';
                else echo '{"action":"copy","error":"'.$this->getLang('error_copy').'"}';
                return;
            }
            if ($action == 'move') {
                if(!dir_copy($srcdir, $dstdir)){
                    echo '{"action":"move","error":"'.$this->getLang('error_move_exist_file').'"}';
                    return;
                }
                if(unlinkDir($srcdir)) echo '{"action":"move","msg":"<strong>'.str_replace($root,'',$dstdir).'</strong> '.$this->getLang('moved').'"}';
                else echo '{"action":"move","error":"'.$this->getLang('error_move').'"}';
                return;
            }
            if ($action == 'rename'){
                if (is_dir($dstdir)){
                    echo '{"action":"rename","error":"'.$this->getLang('error_exist_file').'"}';
                }else if (renameDir($srcdir, $dstdir)){
                    echo '{"action":"rename","msg":"<strong>'.str_replace($root,'',$dstdir).'</strong> '.$this->getLang('renamed').'"}';
                }else{
                    echo '{"action":"rename","error":"'.$this->getLang('error_rename').'"}';
                }
                return;
            }
        }

    }
}
