var clipboard;
function basename(path){
    var t = 'file';
    var m = path.match(/(.*)[\/\\]([^\/\\]+\.\w+)$/);
    if (!m){ 
        m =  path.match(/(.*)[\/\\]([^\/\\]*)[\/\\]$/);
        t = 'dir';
    }
    if(!m[1])m[1]='/';
    return {'path':m[1], 'name':m[2], 'type':t };
}
function getlastdirname(path){
    var p = basename(path);
    return p.name;
}

function isfile(path){ 
    var f = basename(path);
    if (f.type =='file') return f.name
    return false;
}
function fmanagerform(value, btn, action){
    var html = '<p>';
    //html += '<label for="id_dir2">' + label + '</label>&nbsp;';
    html += '<input type="text" name="dir2" id="id_dir2" style="width:80%;" value="'+ value +'"/> &nbsp;';
    html += '<input type="button" name="submit" value="' + btn + '"/>';
    html += '</p>';
    return html;
}
function disabledBtn(disabled){
    $('#fileTreeActions input:button').each(function(){
        if (disabled) $(this).attr('disabled','disabled');  
        else $(this).attr('disabled','');
    });
}
function updateInfo(filename, path, srcid, action){
    if(isfile(path)) $("#fileTreeActions h2").addClass("file");
    else $("#fileTreeActions h2").removeClass("file");
    $("#fileTreeActions h2").html(filename);
    $("#fileTreeActions span.path").html(path);
    $("#id_srcid").val(srcid);
    $("#id_srcpath").val(path);
}
function dataOK(data, target){
    if (typeof data.error != 'undefined'){
        $(target).html(data.error);
        return false;
    }
    return true;
}
function readData(srcid, data, targetmsg, targettree){
    var msg = '';
    if (typeof data.msg != 'undefined'){
        msg = data.msg;
        disabledBtn(true);
        if (typeof targettree != 'undefined' && data.action !='rename'){
            $(targettree).collapseDir(srcid, true);
        }
    }else{
        msg = 'Error';
    }
    $(targetmsg).html(msg);
}			
function deletefile(from){
    if(confirm(''+from+'\n¿Seguro que quieres eliminarlo?')){
        $.post('dokuwikiaction.php', {action:'delete', dir:from }, function(data) {
            var srcid = $("#id_srcid").val();
            if (dataOK(data, '.msg')){ 
                readData('#'+srcid, data, '.msg', '#fileTreeDemo_1');
            }else{ 
                disabledBtn(true);
            }
        }, 'json');
    }            
}	
function copyfile(from, to){
    $.post('dokuwikiaction.php', {action:'copy', dir:from, dir2:to }, function(data, to) {
        var srcid = $("#id_srcid").val();
        if (dataOK(data, '.msg')){ 
            readData('#'+srcid, data, '.msg');
            var p = basename($("#id_dstpath").val());
            if (p.path == '/'){ 
                $('#fileTreeDemo_1').reloadTree();
            }else{ 
                if (p.type == 'dir'){
                    var npath = $("#id_dstpath").val();
                    var parentid = $("#fileTreeDemo_1 a[rel='"+ p.path +"/']").parent().attr('id');
                    $('#fileTreeDemo_1').reloadDir('#'+parentid, p.path +'/' );
                    $("#fileTreeDemo_1 ").find('a.linkactive').removeClass('linkactive');
                    $("#fileTreeDemo_1 a:contains('"+ npath +"')").addClass('linkactive');
                }else{
                    var parentid = $("#fileTreeDemo_1 a[rel='"+p.path+"/']").parent().attr('id');
                    $('#fileTreeDemo_1').reloadDir('#'+parentid, p.path +'/');
                }
            }
        }else{ 
            disabledBtn(true);
        }
    }, 'json');                
}
function movefile(from, to){
    $.post('dokuwikiaction.php', {action:'move', dir:from, dir2:to }, function(data) {
        var srcid = $("#id_srcid").val();
        if (dataOK(data, '.msg')){ 
            readData('#'+srcid, data, '.msg');
            var p = basename(to);
            if (p.path == '/'){ 
                $('#fileTreeDemo_1').reloadTree();
            }else{
                $('#fileTreeDemo_1').collapseDir('#'+srcid,true);
                var parentid = $("#fileTreeDemo_1 a[rel='"+p.path+"/']").parent().attr('id');
                $('#fileTreeDemo_1').reloadDir('#'+parentid, p.path +'/');
            }
        }else{ 
            disabledBtn(true);
        }
    }, 'json');                
}
function renamefile(from, to){
    $.post('dokuwikiaction.php', {action:'rename', dir:from, dir2:to }, function(data) {
        if (dataOK(data, '.msg')){ 
            var srcid = $("#id_srcid").val();
            var newname =  $("#id_dir2").val();			                
            readData(srcid, data, '.msg');
            $('#'+srcid+' a:first').attr('rel',to).html(newname);
            updateInfo(newname, to, srcid);
            if (!isfile(to)){
                $('#fileTreeDemo_1').reloadDir('#'+srcid, to);
            }
        }else{ 
            disabledBtn(true);
        }
    }, 'json');
}
$(document).ready( function() {
    disabledBtn(true);				
    $('#fileTreeDemo_1').fileTree({ root: '/', script: 'dokuFileTree.php', folderEvent: 'click', multiFolder: false }, function(filepath, srcid) { 
        var filename = $('#' + srcid + ' a:first').text();
        updateInfo(filename, filepath, srcid);
        $('.msg').html('');
        disabledBtn(false);
    }, function(action, el, pos){
        if (action != 'paste'){
            updateInfo($(el).text(), $(el).attr('rel'), $(el).parent().attr('id'), action);
            disabledBtn(false); //activa los botones
        }
        if (action == 'rename')
        {
            $("#id_srcpath").val($(el).attr('rel'));
            var p = basename($("#id_srcpath").val());
            $('.msg').html(fmanagerform(p.name, 'renombrar', 'rename'));
            $("#fileTreeActions input[name='submit']").click(function(){
                var from = $("#id_srcpath").val();
                var pathfrom = basename(from);
                var to = pathfrom.path + $("#id_dir2").val();
                if (pathfrom.path != '/') to = pathfrom.path +'/'+ $("#id_dir2").val();
                if (pathfrom.type != 'file') to += '/';
                renamefile(from,to);
            });
        }
        else if (action == 'cut' || action == 'copy')
        { 
            clipboard = {'action':action, 'rel':$(el).attr('rel'), 'srcid':$(el).parent().attr('id')};
            alert(clipboard.rel);
            $("#id_srcid").val(clipboard.srcid);
            $("#id_srcpath").val(clipboard.rel);			            
        }
        else if (action == 'paste')
        { 
            $("#id_srcid").val(clipboard.srcid);
            $("#id_srcpath").val(clipboard.rel);
            $("#id_dstpath").val($(el).attr('rel'));
            //$("#id_dir2").val($(el).attr('rel'));				    
            var p = basename(clipboard.rel);
            var to = $(el).attr('rel') + p.name;
            
            if (clipboard.action == 'cut')
            { 
                if(confirm('cortar ' + clipboard.rel + '\n' +
                           'pegar ' + to + '\n' +
                           '¿Seguro que quieres mover el directorio?')
                   )
                {
                    $("#id_action").val('move');
                    movefile(clipboard.rel, to);
                }
            }
            else if (clipboard.action == 'copy')
            { 
                if(confirm('copiar ' + clipboard.rel + '\n' +
                           'pegar ' + to + '\n' +
                           '¿Seguro que quieres copiar el directorio?')
                   )
                {
                    $("#id_action").val('copy');
                    copyfile(clipboard.rel, to);
                }
            }
        }
        else if (action == 'delete')
        {
            var from = $(el).attr('rel');
            deletefile(from);
        }
    });			
    $("input[name='delete']").click(function(){
        var from = $("#id_srcpath").val();
        deletefile(from);
    });
    $("input[name='copy']").click(function(){
        $('.msg').html(fmanagerform($("#id_srcpath").val(), 'copiar', 'copy'));
        $("#fileTreeActions input[name='submit']").click(function(){
            var from = $("#id_srcpath").val();
            var to = $("#id_dir2").val();
            $("#id_dstpath").val(to);				
            copyfile(from, to);
        });
    });
    $("input[name='move']").click(function(){
        
        $('.msg').html(fmanagerform($("#id_srcpath").val(), 'mover', 'move'));
        $("#fileTreeActions input[name='submit']").click(function(){
            var from = $("#id_srcpath").val();
            var to = $("#id_dir2").val();
            $("#id_dstpath").val(to);
            movefile(from, to);
        });
    });
    $("input[name='rename']").click(function(){
        var p = basename($("#id_srcpath").val());
        $('.msg').html(fmanagerform(p.name, 'renombrar', 'rename'));
        $("#fileTreeActions input[name='submit']").click(function(){
            var from = $("#id_srcpath").val();
            var pathfrom = basename(from)
            var to = pathfrom.path + $("#id_dir2").val();
            if (pathfrom.path != '/') to = pathfrom.path +'/'+ $("#id_dir2").val();
            if (pathfrom.type != 'file') to += '/';
            renamefile(from,to);
        });
    });
    $("input[name='cancel']").click(function(){
        $('.msg').html('');
    });
});
