<?php
function slugify($str){
    $str = trim($str);
    $str = strtr($str,"¥µÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖØÙÚÛÜÝßàáâãäåæçèéêëìíîïðñòóôõöøùúûüýÿ!@#%&*()[]{}+=?",
                      "YuAAAAAAACEEEEIIIIDNOOOOOOUUUUYsaaaaaaaceeeeiiiionoooooouuuuyy_______________");
    $str = str_replace("..","",str_replace("\\","",str_replace("\$","",$str)));
    return $str;
}

function createDir($dirname, $mode = 0777)
{
	mkdir($dirname, $mode);
}


function unlinkDir($dir) {

    if (is_dir($dir) ){
        if(!$dh = opendir($dir)) return false;      
        while (false !== ($obj = readdir($dh))) {
            if($obj == '.' || $obj == '..') continue;
        	if (is_dir($dir .'/'. $obj)) {
        		if (@!rmdir($dir .'/'. $obj)){  
        		    if (!unlinkDir($dir.'/'.$obj)) return false;
    		    }
        	} else {
        		@unlink($dir .'/'. $obj);
        	}
        }
        @closedir($dh);
        return @rmdir($dir); 
    }else if (is_file($dir)){
        return @unlink($dir);
    }
    return false;
}

function dir_copy($from, $to)
{
    $filemode = 0777;
    $dirmode = 0775;
    if(is_file($from)) {
        if(@copy($from, $to)) {
            @touch($to, filemtime($from));
            @chmod($to, $filemode);
            return true;
        }
        else {
            return false;
        }
    }
    
    if(!is_dir($to) && !@mkdir($to)) return false;
    @chmod($to, $dirmode);
    
    if($curdir = opendir($from)) {
        while($file = readdir($curdir)) {
            if($file != '.' && $file != '..') {
                $srcfile = $from . '/' . $file;
                $dstfile = $to . '/' . $file;
                if(is_file($srcfile)) {
                    if(@copy($srcfile, $dstfile)) {
                        @touch($dstfile, filemtime($srcfile));
                        @chmod($dstfile, $filemode);
                    }
                    else {
                        return false;
                    }
                } else if(is_dir($srcfile)){ 
                    if(!dir_copy($srcfile, $dstfile)) return false; 
                }
            }
        }
        closedir($curdir);
    }else{
        return false;
    }
    return true;
}

function renameDir($from, $to)
{
    $mode = 0775;
    $to = slugify($to);
    if (renameWDir($from,$to, $mode)){
        return true;
    }else {
        return false;
    }
}

function renameWDir($from,$to, $mode){
  if(!@rename($from,$to)){
    if(@copy($from,$to)){
      @chmod($to, $mode);
      @unlink($from);
      return true;
    }
    return false;
  }
  return true;
}

?>
